#include<bits/stdc++.h>
using namespace std;
int n,q,m[1004],a[1004];
vector<int> adj[1004];
int dp[1004];
int solve(int vruh){
    if(vruh<0||vruh>=n){
        return 0;
    }
    if((int)adj[vruh].size()==0){
        return 1;
    }
    /*if(dp[vruh]!=1){
        return dp[vruh];
    }*/
    for(int i=0;i<(int)adj[vruh].size();i++){
        if(adj[vruh][i]==0){
            adj[vruh][i]=1;
        }
        dp[vruh]+=solve(adj[vruh][i]);
    }
    return dp[vruh];
}
int main(){
ios_base::sync_with_stdio(false);
cin.tie(NULL);
//freopen("test.txt","r",stdin);
cin>>n;
int u,v;
for(int i=0;i<n-1;i++){
    cin>>u>>v;
    adj[u].push_back(v);
}
cin>>q;
for(int i=0;i<q;i++){
    cin>>m[i];
}
for(int i=0;i<n;i++){
    dp[i]=1;
}
for(int i=0;i<q;i++){
    int kr=solve(m[i])-1;
    if(kr==-1){
        cout<<0<<"\n";
    }
    else{
        cout<<kr<<endl;
    }
}
return 0;
}

